/// <reference types="node" />
import { Query, Mutation, Options, ResolveResult } from "./w3";
import { Client, Plugin, PluginFactory, PluginPackageManifest } from "@web3api/core-js";
import CID from "cids";
export interface IpfsConfig {
    provider: string;
    fallbackProviders?: string[];
}
export declare class IpfsPlugin extends Plugin {
    private _config;
    private _ipfs;
    constructor(_config: IpfsConfig);
    static manifest(): PluginPackageManifest;
    static isCID(cid: string): boolean;
    getModules(_client: Client): {
        query: Query.Module;
        mutation: Mutation.Module;
    };
    setProvider(provider: string): void;
    add(data: Uint8Array): Promise<{
        name: string;
        hash: CID;
    }>;
    cat(cid: string, options?: Options): Promise<Buffer>;
    catToString(cid: string, options?: Options): Promise<string>;
    resolve(cid: string, options?: Options): Promise<ResolveResult>;
    private _execWithOptions;
}
export declare const ipfsPlugin: PluginFactory<IpfsConfig>;
export declare const plugin: PluginFactory<IpfsConfig>;
